package com.common.library.cache;

import com.common.library.base.LibBaseActivity;
import com.common.library.utils.FileUtils;
import com.common.library.utils.MD5Utils;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/**
 * Created by fucl on 2016/4/5.
 */
public class Cache<T> {

    /**
     * 文件对象缓存路径
     */
    public static Map<String, Object> CacheMap = new ConcurrentHashMap<>();
    // 创建一个固定大小的线程池
    private static ExecutorService service = Executors.newFixedThreadPool(1);

    public static void put(String key, Object obj) {
        service.execute(new MyRunnable(key, obj));
    }

    public static Object getObj(String key) {
        Object obj = CacheMap.get(key);
        if (obj == null) {
            obj = FileUtils.readSerializable(LibBaseActivity.CACHEPATH + "" + MD5Utils.ecode(key));
        }
        return obj;
    }

    @SuppressWarnings("unchecked")
    public T get(String key) {
        Object obj = CacheMap.get(key);
        if (obj == null) {
            obj = FileUtils.readSerializable(LibBaseActivity.CACHEPATH + "" + MD5Utils.ecode(key));
            if (obj != null) {
                CacheMap.put(key, obj);
            }
        }
        return (T) obj;
    }

    /**
     * 清除缓存数据
     * @param key
     */
    public static void clean(String key){
        try {
            CacheMap.remove(key);
            FileUtils.delectSerializable(LibBaseActivity.CACHEPATH + "" + MD5Utils.ecode(key));
        } catch (Exception e){
            e.printStackTrace();
        }
    }
}

class MyRunnable implements Runnable {

    private String key;
    private Object obj;

    public MyRunnable(String key, Object obj) {
        this.key = key;
        this.obj = obj;
    }

    @Override
    public void run() {
        Cache.CacheMap.put(key, obj);
        FileUtils.writeSerializable(obj, LibBaseActivity.CACHEPATH + "" + MD5Utils.ecode(key));
    }
}
